Attribute VB_Name = "Module1"
Option Explicit

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Type FILETIME
     dwLow As Long
     dwHigh As Long
End Type

Private Type TIME_ZONE_INFORMATION
    Bias As Long
    StandardName(0 To 31) As Integer
    StandardDate As SYSTEMTIME
    StandardBias As Long
    DaylightName(0 To 31) As Integer
    DaylightDate As SYSTEMTIME
    DaylightBias As Long
End Type
Const MAX_PATH As Integer = 260

Private Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * MAX_PATH
End Type
Const TH32CS_SNAPPROCESS = &H2
Const PROCESS_QUERY_INFORMATION = &H400&

Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Private Declare Function Process32First Lib "kernel32" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Sub CloseHandle Lib "kernel32" (ByVal hPass As Long)

Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, _
                                                              lpSystemTime As SYSTEMTIME) As Long
Private Declare Function SystemTimeToLocalTime Lib "kernel32" Alias "SystemTimeToTzSpecificLocalTime" _
                (ByVal lpTZ As Long, lpUniversalTime As SYSTEMTIME, lpLocalTime As SYSTEMTIME) As Long
Private Declare Function GetProcessTimes Lib "kernel32" (ByVal hProcess As Long, lpCreationTime As FILETIME, _
                lpExitTime As FILETIME, lpKernelTime As FILETIME, lpUserTime As FILETIME) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long

Public Function GetStartTime(ByRef dt As Date) As Boolean
   Dim pid As Long, hProc As Long
   pid = GetPid("winlogon.exe")
   If pid Then
      hProc = OpenProcess(PROCESS_QUERY_INFORMATION, 0, pid)
      If hProc Then
         Dim created As FILETIME, ft As FILETIME
         If GetProcessTimes(hProc, created, ft, ft, ft) Then
            dt = FileTimeToVBDate(created, False)
            GetStartTime = True
         End If
         CloseHandle hProc
      End If
   End If
End Function

Private Function GetPid(ByVal procName As String) As Long
   Dim hSnap As Long, r As Long, pe32 As PROCESSENTRY32
   hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0&)
   pe32.dwSize = Len(pe32)
   r = Process32First(hSnap, pe32)

   Do While r
      If UCase$(procName) = UCase$(TrimNull(pe32.szExeFile)) Then
         GetPid = pe32.th32ProcessID
         Exit Do
      End If
      r = Process32Next(hSnap, pe32)
   Loop
   CloseHandle hSnap
End Function

Private Function FileTimeToVBDate(ft As FILETIME, Optional bUTC As Boolean = True) As Date
  Dim st As SYSTEMTIME
  FileTimeToSystemTime ft, st
  If Not bUTC Then
     SystemTimeToLocalTime 0, st, st
  End If
  On Error Resume Next
  FileTimeToVBDate = DateSerial(st.wYear, st.wMonth, st.wDay) + _
                     TimeSerial(st.wHour, st.wMinute, st.wSecond) ' + st.wMilliseconds / 86400 / 1000
  If Err Then
     Err.Clear
     FileTimeToVBDate = DateSerial(1600, 1, 1)
  End If
End Function

Private Function TrimNull(startstr As String) As String
   Dim pos As Integer
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function

